
/***********************************************************************
   Widgetklasse: XwHistspectrWidgetClass

$Revision: 2.1 $

$Log: Whistspectr.h,v $
Revision 2.1  2003/12/27 13:41:22  keidel
Whistspectr added




    Copyright 2003,  WizAnt Software  
    		Jrgen Keidel  
   		Bergstrasse 15
   		D 85080 Gaimersheim
   		Tel: D  08406 379
   		E-mail: wizant.keidel@freenet.de
                                                                 
   Permission to use, copy, modify, and to distribute this software  
   and its documentation for any purpose is hereby granted without   
   fee, provided that the above copyright notice appear in all       
   copies and that both that copyright notice and this permission    
   notice appear in supporting documentation.  There is no           
   representations about the suitability of this software for        
   any purpose.  this software is provided "as is" without express   
   or implied warranty.      

   Date:		Tue Dec  9 08:08:53 CET 2003


 ***********************************************************************/

#ifndef __histspectr_h
#define __histspectr_h

#include <Xm/Xm.h>
#include <WhistspectrP.h>
#ifdef __cplusplus
extern "C" {
#endif

#define XwIsHistspectr(w)  (XtIsSubclass (w, XwHistspectrWidgetClass))


/* wHistspectr Callackstruct */
typedef struct {
  int 		reason;
  XEvent 	*event;
  int 		fd;
  Dimension	width;
  Dimension	height;		/* Dimensions of visible Bars Window */
}XwHistspectrCallbackStruct;

typedef struct {
    float x;
    float y;
}w3dPoint;

externalref WidgetClass XwHistspectrWidgetClass;


/* define set/getargs names  */

#define  XwHistspectrDefaultHistsize    200	/* Default size of history buffer */
#define  XwHistspectrDefaultAngle       45	/* Default angle of Time-Axis */

#define  XwCHistspectrLines         "HistspectrLines"
#define  XwNhistspectrLines         "histspectrLines"
#define  XwCHistspectrAngle         "HistspectrAngle"
#define  XwNhistspectrAngle         "histspectrAngle"
#define  XwCHistspectrBackground    "HistspectrBackground"   /* curve background */
#define  XwNhistspectrBackground    "histspectrBackground"
#define  XwCHistspectrAnnotation    "HistspectrAnnotation"
#define  XwNhistspectrAnnotation    "histspectrAnnotation"
#define  XwCHistspectrAnnotColor    "HistspectrAnnotColor"
#define  XwNhistspectrAnnotColor    "histspectrAnnotColor"
#define  XwNhistspectrGridScale     "histspectrGridScale"
#define  XwCHistspectrGridScale	    "HistspectrGridScale"
#define  XwNhistspectrScale         "histspectrScale"
#define  XwCHistspectrScale         "HistspectrScale"
#define  XwNhistspectrAnnotTNdec    "histspectrAnnotTNdec"
#define  XwCHistspectrAnnotTNdec    "HistspectrAnnotTNdec"
#define  XwNhistspectrAnnotYNdec    "histspectrAnnotYNdec"
#define  XwCHistspectrAnnotYNdec    "HistspectrAnnotYNdec"
#define  XwNhistspectrAnnotXNdec    "histspectrAnnotXNdec"
#define  XwCHistspectrAnnotXNdec    "HistspectrAnnotXNdec"
#define  XwNhistspectrAnnotTNgrid   "histspectrAnnotTNgrid"
#define  XwCHistspectrAnnotTNgrid   "HistspectrAnnotTNgrid"
#define  XwNhistspectrAnnotYNgrid   "histspectrAnnotYNgrid"
#define  XwCHistspectrAnnotYNgrid   "HistspectrAnnotYNgrid"
#define  XwNhistspectrAnnotXNgrid   "histspectrAnnotXNgrid"
#define  XwCHistspectrAnnotXNgrid   "HistspectrAnnotXNgrid"
#define  XwNhistspectrFill	    "histspectrFill"            /* curve fill */
#define  XwCHistspectrFill	    "HistspectrFill"
#define  XwNhistspectrAddvalue	    "histspectrAddvalue"
#define  XwCHistspectrAddvalue	    "HistspectrAddvalue"
#define  XwNhistspectrAddtext	    "histspectrAddtext"
#define  XwCHistspectrAddtext	    "HistspectrAddtext"
#define  XwNhistspectrCurveColor    "histspectrCurveColor"
#define  XwCHistspectrCurveColor    "HistspectrCurveColor"
#define  XwNhistspectrAutoscale	    "histspectrAutoscale"
#define  XwCHistspectrAutoscale	    "HistspectrAutoscale"

enum autosc {NoAuto=0 , AutoTime , AutoAbs=2 , AutoAmpl=4 };

/********    Public Function Declarations    ********/
#ifdef _NO_PROTO

extern Widget   XwCreateHistspectr   () ;
extern void     XwHistdoscan          ();   
extern void     XwHistspectrSettext  ();
extern void     XwHistspectrSetMarker();
#else

extern Widget   XwCreateHistspectr    (Widget parent,char *name,ArgList arglist,Cardinal argcount) ;
extern void     XwHistdoscan          (Widget w ,  w3dPoint xy[], int npoints , float time );   
extern void     XwHistspectrSettext   (Widget cw, char *text);
extern void     XwHistspectrSetMarker (Widget w ,float x);

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _WHistspectr_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
                    
