/***********************************************************************
   Widgetklasse: XwHistspectrWidgetClass

$Revision: 2.1 $

$Log: WhistspectrP.h,v $
Revision 2.1  2003/12/27 13:41:22  keidel
Whistspectr added





   Copyright 2003,  WizAnt Software  
    		Jrgen Keidel  
   		Bergstrasse 15
   		D 85080 Gaimersheim
   		Tel: D  08406 379
   		E-mail: wizant.keidel@freenet.de
         
                                                                  
   Permission to use, copy, modify, and to distribute this software  
   and its documentation for any purpose is hereby granted without   
   fee, provided that the above copyright notice appear in all       
   copies and that both that copyright notice and this permission    
   notice appear in supporting documentation.  There is no           
   representations about the suitability of this software for        
   any purpose.  this software is provided "as is" without express   
   or implied warranty.      

   Date:		Tue Dec  9 08:07:30 CET 2003


   
 ***********************************************************************/

#ifndef	_histspectr_h
#define _histspectr_h


#include <Xm/PrimitiveP.h>
#include <Xm/DrawingAP.h>
#include <Whistspectr.h>

#ifdef __cplusplus
extern "C" {
#endif
/*Histspectr  class structure */

#define minsize 64
typedef struct _XwHistspectrClassPart
{
   XtPointer 	extension;   /* Pointer to extension record */
} XwHistspectrClassPart;


/* Full class record declaration for wHistspectr class */

typedef struct _XwHistspectrClassRec {
    CoreClassPart	  	core_class;
    XmPrimitiveClassPart  	primitive_class;
    XwHistspectrClassPart  	histspectr_class;
} XwHistspectrClassRec, *XwHistspectrWidgeteClass;


externalref XwHistspectrClassRec xwHistspectrClassRec;

/*  wHistspectr instance record */

#ifndef _ScScale_ 
typedef struct {
	double		at;
	double		bt;		/* scaling timeaxis */        
	double		ax;
	double		bx;		/* scaling abscissa */
	double		ay;
	double		by;		/* scaling ordinate */
}ScScale;
#define _ScScale_ 
#endif 




typedef struct _XwHistspectrPart
{
   /* public part */
 	Pixel   	background;	/* color */
   	Pixel   	anncolor;	/* color of annotation*/
	Pixel           fillcolor;	/* colour as pixel */
	Pixel           linecolor;	/* shadecolour as pixel */
   	int		Angle;		/* Angle of history axis (90 to 0 degrees */
	float		*vis;		/* scaling info of visible part  array min/max  as x  y*/
	float		*gr;		/* grid base and delta    x/t/y*/
	int		tndecimals;	/* number of decimals for annotation */
	long int	tnthgridanno;	/* annotation every nth gridline abscissa*/
	int		yndecimals;	/* number of decimals for annotation */
	long int	ynthgridanno;	/* annotation every nth gridline ordinate*/
	int		xndecimals;	/* number of decimals for annotation */
	long int	xnthgridanno;	/* annotation every nth gridline abscissa*/
        float           marker;
    	short int  	anflag;		/* flag where annotation , 0 NO , 1 y left, time right */
        short int  	lines;          /* curve as lines or points */
        short int	autoscale;      /* fgs for autoscaling */
	short int 	dofixtext;   	/* allow setting of fixed text */
	XmFontList 	font_list;		/* fontlist for annotation */
	XFontStruct 	*font_struct;
  	XtCallbackList 	expose_callback;
    	XtCallbackList 	resize_callback;

/*  private part */
	Dimension 	oldx;		/* last abscissa position in pixels */
	Dimension 	oldy;		/* last ordinate position in pixels */
	float		foldx;
	float		foldy;
	float 		lasttim;
	Dimension	Xpos;		/* bar position in visible window */
	char		*fixtext;		/* if no zero && not empty draw fix text */
        XPoint          *curve;         /* internal storage for curve */
        int             curvepoint;     /* allocate storage for curve */
     	Dimension 	width;
 	Dimension 	height;		/* own visible dimensions, used for resize */
 	Dimension 	xv;
 	Dimension 	yv;		/* own visible dimensions if outside bar area
 					 start */
 	Dimension	annsiz;		/* size of annotation pixmap */				 
  	Dimension 	pixwidth;
	Dimension 	pixheight;	/* dimensions of pixmap */
	double		angle;		/* angle of time-axis in radians */
	float		prevgrid;	/* actual last grid start */
	int		lastanncnt;
	GC		gc;		/* graphic context */
	GC		anngc;		/* graphic context annotation */
	Pixmap		pix;		/* pixmap for histspectr */
	Pixmap		panno;		/* pixmap for histspectr annotation */
	ScScale		sc;		/* Scaling to pixels */
        int             mark;
	int 		exposed;
	double      	Xoffset;
	double      	Yoffset;
}XwHistspectrPart;	

/* Full instance record declaration */

typedef struct _XwHistspectrRec {
    CorePart	     	core;
    XmPrimitivePart  	primitive;
    XwHistspectrPart  	histspectr;
 } XwHistspectrRec, *XwHistspectrWidget;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XwHistspectrP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
